<template>
  <div class="app-container">
    <div v-if="isPercentage" class="percentage" style="width: 210px;height: 90px;background: #fff;position: fixed;bottom: 0;left: 0;z-index: 9999999999999;">
      <h4 style="padding-left: 10px;line-height: 0;">导出进度：</h4>
      <el-progress style="padding-left: 10px;" :text-inside="true" :stroke-width="26" :percentage="percentage" />
    </div>
    <div class="filter-container">
      <el-select v-model="getdataListParm.parammaps.pastureName" style="width: 140px;" placeholder="牧场" class="filter-item" @change="changePastureName">
        <el-option v-for="item in findAllPasture" :key="item.id" :label="item.name" :value="item.name" />
      </el-select>
      <el-input v-model="getdataListParm.parammaps.orderNumber" placeholder="申购单号" style="width: 200px;" class="filter-item" />
      <el-select v-model="getdataListParm.parammaps.stuteSH" style="width: 140px;" clearable placeholder="审核状态" class="filter-item">
        <el-option v-for="item in statues" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-select v-model="getdataListParm.parammaps.departmentId" clearable style="width: 140px;" placeholder="申购部门" class="filter-item">
        <el-option v-for="item in findAllDepart" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-select v-model="getdataListParm.parammaps.purchase_type" clearable style="width: 140px;" placeholder="申购状态" class="filter-item">
        <el-option v-for="item in subscriptionStatusList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-input v-model="getdataListParm.parammaps.empName" placeholder="申购人" style="width: 200px;" class="filter-item" />
      <!-- <el-select v-model="getdataListParm.parammaps.empName " style="width: 140px;" placeholder="申购人" class="filter-item">
        <el-option v-for="item in findAllEmploye" :key="item.id" :label="item.name" :value="item.id" />
      </el-select> -->
      <el-date-picker ref="inputDatetime" v-model="getdataListParm.parammaps.inputDatetime" class="inputDatetime" type="datetimerange" style="width: 250px;top:-3px;" format="yyyy-MM-dd" value-format="yyyy-MM-dd" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" />
      <el-button v-waves class="filter-item" type="primary" icon="el-icon-search" @click="form_search">搜索</el-button>
      <div>

        <el-button v-if="isSubscribeAdd" class="filter-item" type="primary" icon="el-icon-edit" @click="form_add">新增</el-button>
        <el-button v-if="isSubscribeSpecial" class="filter-item" type="primary" icon="el-icon-edit" @click="handle_specialSubscription">特殊申购</el-button>
        <el-button v-if="isSubscribeExport" v-waves class="filter-item" type="success" icon="el-icon-upload2" @click="handleDownload">导出</el-button>
        <el-radio-group v-model="radioAll" style="margin-top:-9px" @change="changeAll()">
          <el-radio-button label="全部" />
          <el-badge :value="pending.total" class="item">
            <el-radio-button label="待处理" />
          </el-badge>
          <el-radio-button label="已处理" />
        </el-radio-group>
      </div>
    </div>
    <div class="filter-button" />

    <el-table
      :key="tableKey"
      v-loading="listLoading"
      element-loading-text="给我一点时间"
      :data="list"
      border
      fit
      highlight-current-row
      style="width: 100%;"
      :row-style="rowStyle"
      :cell-style="cellStyle"
      class="elTable"
      :max-height="myHeight"
    >
      <el-table-column label="序号" align="center" type="index" width="50px">
        <template slot-scope="scope">
          <span>{{ scope.$index + (pageNum-1) * pageSize + 1 }}</span>
        </template>
      </el-table-column>
      <el-table-column label="申购单号" min-width="150px" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.orderNumber }}</span>
        </template>
      </el-table-column>
      <el-table-column label="牧场" min-width="90px" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.pastureName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="申购部门" min-width="80px" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.departmentName }}</span>
        </template>
      </el-table-column>

      <el-table-column label="申购人" min-width="80px" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.empname }}</span>
        </template>
      </el-table-column>
      <el-table-column label="申购日期" sortable prop="inputTime" min-width="80px" align="center" />
      <el-table-column label="申购状态" min-width="80px" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.purchase_type == 1">暂估</span>
          <span v-else-if="scope.row.purchase_type == 3">赠品</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>
      <el-table-column label="审核状态" min-width="80px" align="center" :formatter="statue" />
      <el-table-column label="操作" align="center" width="250" class-name="small-padding fixed-width" fixed="right">
        <template slot-scope="{row}">
          <el-button v-if="isSubscribeSee" type="primary" size="mini" @click="form_see(row)">查看</el-button>
          <el-button v-if="row.statue == 4||row.statue == 6||row.statue == 8||row.statue == 10||row.statue == 12 ||row.statue == 14" style="display:inline-block" type="success" size="mini" @click="form_edit(row)">编辑</el-button>
          <el-button v-else style="display:none" type="success" size="mini" @click="form_edit(row)">编辑</el-button>
          <!-- 库管 -->
          <el-button v-if="isSubscribeExamineKG && row.statue == 2" style="display:inline-block" type="success" size="mini" @click="handleExamine1(row)">审核1</el-button>

          <!-- 设备 -->
          <el-button v-if="isSubscribeExamineSBZG && row.statue == 3" style="display:inline-block" type="success" size="mini" @click="handleExamine2(row)">审核2</el-button>

          <!-- 供应商主管 -->
          <el-button v-if="isSubscribeExamineZG && row.statue == 9" style="display:inline-block" type="success" size="mini" @click="handleExamine3(row)">审核3</el-button>




          <!-- 场长 -->
          <el-button v-if="sdchangzhangshenhe  && (row.purchase_type < 0 || row.purchase_type == 0) &&  row.statue == 5" style="display:inline-block" type="success" size="mini" @click="handleExamine4(row)">审核4</el-button>

          <el-button v-if="sdchangzhangshenhe  && row.purchase_type > 0 &&  row.statue == 13" style="display:inline-block" type="success" size="mini" @click="handleExamine4(row)">审核4</el-button>




          <!-- 采购 -->
          <el-button v-if="isSubscribeExamineCG && row.statue == 11 " style="display:inline-block" type="success" size="mini" @click="handleExamine5(row)">审核5</el-button>

          <!-- 财务 -->
          <el-button v-if="isSubscribeExamineCW && row.purchase_type > 0 && row.statue == 5 " style="display:inline-block" type="success" size="mini" @click="handleExamine6(row)">审核6</el-button>

          <el-button v-if="isSubscribeDelete && (row.statue == 4||row.statue == 6||row.statue == 8||row.statue == 12)" style="display:inline-block" type="danger" size="mini" @click="form_delete(row)">删除</el-button>



          <el-button v-else style="display:none" type="danger" size="mini" @click="form_delete(row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total>0" :total="total" :page.sync="getdataListParm.offset" :limit.sync="getdataListParm.pagecount" @pagination="get_table_data" />
    <!-- 弹出层新增or修改 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" :close-on-click-modal="false" width="90%">
      <div class="app-container">
        <el-form
          ref="createTemp"
          :rules="rules"
          :model="createTemp"
          label-position="right"
          label-width="100px"
          style="width: 90%;margin:0 auto;"
        >
          <el-row>
            <el-col :span="8">
              <el-form-item label="申购单号：" prop="orderNumber">
                <el-input ref="orderNumber" v-model="createTemp.orderNumber" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="牧场：" prop="pastureId">
                <el-select v-model="createTemp.pastureId" placeholder="牧场" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'" @change="changePasture">
                  <el-option v-for="item in findAllPasture" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="申购部门：" prop="departmentId">
                <el-select v-model="createTemp.departmentId" placeholder="申购部门" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'" @change="changeDepart">
                  <el-option v-for="item in createDepartList" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="申购人：" prop="employeId">
                <el-select v-model="createTemp.employeId" placeholder="申购人" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'">
                  <el-option v-for="item in findAllEmploye" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="申购日期：" prop="createTime">
                <el-date-picker v-model="createTemp.createTime" :picker-options="pickerOptions" type="date" placeholder="申购日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width:100%" :disabled="dialogStatus==='update'" />
              </el-form-item>
            </el-col>
            <el-col v-if="dialogStatus==='create'" :span="8">
              <el-form-item label="线上采购：" prop="providerId">
                <el-select v-model="createTemp.providerId" placeholder="线上采购" clearable class="filter-item" style="width:100%" @change="changeProvider">
                  <el-option v-for="item in onlineSubscriptionList" :key="item.id" :label="item.providerName" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col v-if="dialogStatus==='update'" :span="8">
              <el-form-item label="线上采购：" prop="providerName">
                <el-input ref="providerName" v-model="createTemp.providerName" disabled />
              </el-form-item>
            </el-col>
            <el-col v-if="dialogStatus==='special' && createTemp.purchaseType == '1' || createTemp.purchaseType == '3'" :span="8">
              <el-form-item label="供应商：" prop="providerId">
                <el-select v-model="createTemp.providerId" placeholder="供应商" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'">
                  <el-option v-for="item in providerList" :key="item.id" :label="item.providerName" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col v-if="dialogStatus==='special' && createTemp.purchaseType == '2'" :span="8">
              <el-form-item label="供应商：" prop="providerId">
                <el-input ref="providerName" v-model="createTemp.providerName" />
                <!-- <el-select v-model="createTemp.providerId" placeholder="供应商" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'">
                  <el-option v-for="item in providerList" :key="item.id" :label="item.providerName" :value="item.id" />
                </el-select> -->
              </el-form-item>
            </el-col>
            <el-col  :span="8" v-if="dialogStatus==='special' && createTemp.purchaseType == '2'">
              <el-form-item label="垫付人：" prop="funderId">
                <el-select v-model="createTemp.funderId" filterable placeholder="垫付人" class="filter-item" style="width:100%" :disabled="dialogStatus==='update'">
                  <el-option v-for="item in findAllEmploye" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row v-if="dialogStatus==='special'">
            <el-col :span="24">
              <el-form-item label="申购类型：" prop="purchaseType">
                <el-radio v-model="createTemp.purchaseType" label="1" @change="changeType()">暂估</el-radio>
                <!-- <el-radio v-model="createTemp.purchaseType" label="2" @change="changeType()">垫付</el-radio> -->
                <el-radio v-model="createTemp.purchaseType" label="3" @change="changeType()">赠品</el-radio>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="16">
              <el-form-item label="备件：" prop="partCode">
                <el-autocomplete
                  v-model="createTemp.partCode"
                  value-key="name"
                  class="inline-input"
                  :fetch-suggestions="sparePartSearch"
                  placeholder="请输入备件编号或备件名称或备件规格"
                  style="width:100%"
                  @select="handleSelectSparePart"
                >
                  <template slot-scope="{ item }">
                    <b>备件编号：</b><div class="name" style="display: inline;">{{ item.partCode }}</div>&nbsp;
                    |  &nbsp;<b>备件名称：</b><span class="addr">{{ item.partName }}</span>&nbsp;
                    |  &nbsp;<b>备件规格：</b><span class="addr">{{ item.specification }}</span>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <el-table
          :key="tableKey"
          v-loading="listLoading"
          element-loading-text="给我一点时间"
          :data="listAdd"
          border
          fit
          highlight-current-row
          style="width: 100%;margin-bottom:30px"
          :row-style="rowStyle"
          :cell-style="cellStyle"
          class="elTable"
        >
          <!-- table表格 -->
          <el-table-column label="序号" align="center" type="index" width="50px" />
          <el-table-column label="备件编号" prop="partCode" align="center" min-width="90">
            <template slot-scope="scope">
              <span>{{ scope.row.partCode }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件名称" prop="partName" align="center" min-width="90">
            <template slot-scope="scope">
              <span>{{ scope.row.partName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件规格" prop="specification" min-width="80px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.specification }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件图片" prop="picpath" min-width="110px" align="center">
            <template slot-scope="scope">
              <el-popover placement="right" title="" trigger="hover">
                <img v-if="scope.row.picpath !== ''" :src="scope.row.picpath">
                <img v-if="scope.row.picpath !== ''" slot="reference" :src="scope.row.picpath" :alt="scope.row.srcpath" style="height: 100px;width:100px;">
              </el-popover>
            </template>
          </el-table-column>
          <el-table-column label="备件品牌" prop="brand" align="center" min-width="60">
            <template slot-scope="scope">
              <span v-if="dialogStatus==='create'">{{ scope.row.brandName }}</span>
              <span v-if="dialogStatus==='update'">{{ scope.row.brandName }}</span>
              <span v-if="dialogStatus==='special'">{{ scope.row.brandName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="计量单位" prop="unit" align="center" min-width="60">
            <template slot-scope="scope">
              <span>{{ scope.row.unit }}</span>
            </template>
          </el-table-column>
          <el-table-column label="现有库存" prop="reportery" align="center" min-width="60">
            <template slot-scope="scope">
              <span v-if="createTemp.providerId == '' || parseFloat(createTemp.purchaseType) > 0">{{ scope.row.reportery }}</span>
            </template>
          </el-table-column>
          <el-table-column v-if="dialogStatus==='special'" label="价格" prop="price" align="center" min-width="60">
            <template slot-scope="scope">
              <span v-if="createTemp.purchaseType == '1'">{{ scope.row.price }}</span>
              <el-form v-else :model="scope.row" :rules="rules">
                <el-form-item prop="price">
                  <el-input v-model="scope.row.price" style="margin-top:15px" />
                </el-form-item>
              </el-form>
            </template>
          </el-table-column>
          <el-table-column v-else label="价格" prop="price" align="center" min-width="60">
            <template slot-scope="scope">
              <span v-if="createTemp.providerId == ''">{{ scope.row.price }}</span>
              <el-form v-else :model="scope.row" :rules="rules">
                <el-form-item prop="price">
                  <el-input v-model="scope.row.price" style="margin-top:15px" />
                </el-form-item>
              </el-form>
            </template>
          </el-table-column>
          <el-table-column label="申购数量" min-width="120px" align="center" valign="middle">
            <template slot-scope="scope">
              <el-form :model="scope.row" :rules="rules">
                <el-form-item prop="amount">
                  <el-input v-model="scope.row.amount" style="margin-top:15px" />
                </el-form-item>
              </el-form>
            </template>
          </el-table-column>
          <el-table-column label="备注" min-width="110px" align="center" valign="middle">
            <template slot-scope="scope">
              <el-input v-model="scope.row.purpose" />
            </template>
          </el-table-column>
          <el-table-column
            label="操作"
            align="center"
            width="100"
            class-name="small-padding fixed-width"
            fixed="right"
          >
            <template slot-scope="{row}">
              <a class="del" @click="partDelete(row)">删除</a>
            </template>
          </el-table-column>
        </el-table>
        <div slot="footer" class="dialog-footer" style="bottom:10px">
          <el-button type="primary" :disabled="isokDisable" v-if="dialogStatus==='create'" @click="add_dialog_save()">保存并关闭</el-button>
          <el-button type="primary" :disabled="isokDisable" v-else-if="dialogStatus==='update'" @click="edit_dialog_save()">保存并关闭</el-button>
          <el-button type="primary" :disabled="isokDisable" v-else-if="dialogStatus==='special'" @click="special_dialog_save()">保存并关闭</el-button>
          <el-button @click="dialogFormVisible = false;get_table_data()">取消并关闭</el-button>
        </div>
      </div>
    </el-dialog>
    <!-- 查看 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisibleSee" :close-on-click-modal="false" width="90%">
      <div class="app-containerSee">
        <el-form
          ref="seeTemp"
          :rules="rules"
          :model="seeTemp"
          label-position="right"
          label-width="100px"
          style="width: 90%;margin:0 auto;"
        >
          <el-row>
            <el-col :span="8">
              <el-form-item label="申购单号：" prop="orderNumber">
                <el-input ref="orderNumber" v-model="seeTemp.orderNumber" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="牧场：" prop="pastureId">
                <el-select v-model="seeTemp.pastureId" placeholder="牧场" class="filter-item" disabled style="width:100%">
                  <el-option v-for="item in findAllPasture" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="申购部门：" prop="departmentName">
                <el-input ref="departmentName" v-model="seeTemp.departmentName" disabled />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="申购人：" prop="empname">
                <el-input ref="empname" v-model="seeTemp.empname" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="申购日期：" prop="createTime">
                <el-date-picker v-model="seeTemp.createTime" :picker-options="pickerOptions" type="date" placeholder="申购日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width:100%" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8" v-if="seeTemp.purchaseType == '2'">
              <el-form-item label="供应商：" prop="funderProviderName ">
                <el-input ref="funderProviderName " v-model="seeTemp.funderProviderName " disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8" v-if="seeTemp.purchase_type > 0 && seeTemp.purchaseType !== '2'">
              <el-form-item label="供应商：" prop="providerName">
                <el-input ref="providerName" v-model="seeTemp.providerName" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8" v-if="seeTemp.purchaseType == '2'">
              <el-form-item label="垫付人：" prop="funder_name">
                <el-input ref="funder_name" v-model="seeTemp.funder_name" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8" v-if="seeTemp.purchase_type < 1">
              <el-form-item label="线上采购：" prop="providerName">
                <el-input ref="providerName" v-model="seeTemp.providerName" disabled />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row v-if="seeTemp.purchase_type > 0">
            <el-col :span="24">
              <el-form-item label="申购类型：" prop="purchaseType">
                <el-radio v-model="seeTemp.purchaseType" disabled label="1">暂估</el-radio>
                <!-- <el-radio v-model="seeTemp.purchaseType" disabled label="2">垫付</el-radio> -->
                <el-radio v-model="seeTemp.purchaseType" disabled label="3">赠品</el-radio>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <el-table
          :key="tableKey"
          v-loading="listLoadingSee"
          element-loading-text="给我一点时间"
          :data="listSee"
          border
          fit
          highlight-current-row
          style="width: 100%;margin-bottom:30px"
          :row-style="rowStyle"
          :cell-style="cellStyle"
          class="elTable"
          @sort-change="tableSort"
        >
          <el-table-column type="index" label="序号" align="center" width="50px" />
          <el-table-column label="备件编号" prop="partCode" align="center" min-width="90">
            <template slot-scope="scope">
              <span>{{ scope.row.partCode }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件名称" prop="partName" align="center" min-width="90">
            <template slot-scope="scope">
              <span>{{ scope.row.partName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件规格" prop="specification" min-width="90px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.specification }}</span>
            </template>
          </el-table-column>
          <el-table-column label="备件图片" prop="picpath" min-width="110px" align="center">
            <template slot-scope="scope">
              <el-popover placement="right" title="" trigger="hover">
                <img v-if="scope.row.picpath !== ''" :src="scope.row.picpath">
                <img v-if="scope.row.picpath !== ''" slot="reference" :src="scope.row.picpath" :alt="scope.row.srcpath" style="height: 100px;width:100px;">
              </el-popover>
            </template>
          </el-table-column>
          <el-table-column label="备件品牌" prop="brandName" align="center" min-width="60">
            <template slot-scope="scope">
              <span>{{ scope.row.brandName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="计量单位" prop="unit" align="center" min-width="60">
            <template slot-scope="scope">
              <span>{{ scope.row.unit }}</span>
            </template>
          </el-table-column>
          <el-table-column label="现有库存" sortable prop="storageAmount" align="center" min-width="60" />
          <el-table-column label="价格" sortable prop="price" align="center" min-width="60" />
          <el-table-column label="申购数量" sortable prop="amount" align="center" min-width="60" />
          <el-table-column label="备注" min-width="110px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.purpose }}</span>
            </template>
          </el-table-column>
        </el-table>
        <el-form
          ref="seeTemp"
          :rules="rules"
          :model="seeTemp"
          label-position="right"
          label-width="100px"
          style="width: 90%;margin:0 auto;"
        >
          <el-row>
            <el-col>
              <el-form-item label="流程进度" />
              <el-steps :active="active" align-center finish-status="success">
                <el-step
                  v-for="(item,index) in activeList"
                  :key="index"
                  :title="item.title"
                  :status="item.status"
                >
                  <template slot="description">
                    <div class="step-row">
                      <div>{{ item.name }}&nbsp;&nbsp;{{ item.date }}</div>
                      <div>{{ item.reason }}</div>
                    </div>
                  </template>
                </el-step>
              </el-steps>
            </el-col>
          </el-row>
          <el-row>
            <el-col>
              <el-form-item label="操作:">
                <!-- 库管 -->
                <el-button v-if="isSubscribeExamineKG && seeTemp.statue == 2" type="success" style="display:inline-block" @click="handleExamine1(row)">审核1</el-button>
               <!-- 设备 -->
               <el-button v-if="isSubscribeExamineSBZG && seeTemp.statue == 3" type="success" style="display:inline-block" @click="handleExamine2(row)">审核2</el-button>
                <!-- 供应商主管 -->
                <el-button v-if="isSubscribeExamineZG && seeTemp.statue == 9" type="success" style="display:inline-block" @click="handleExamine3(row)">审核3</el-button>

                <!-- 场长 -->
                <el-button v-if=" sdchangzhangshenhe  && (seeTemp.purchase_type < 0 || seeTemp.purchase_type == 0) && seeTemp.statue == 5" type="success" style="display:inline-block" @click="handleExamine4(row)">审核4</el-button>
                <el-button v-if=" sdchangzhangshenhe  &&  seeTemp.statue == 13" type="success" style="display:inline-block" @click="handleExamine4(row)">审核4</el-button>


                <!-- 采购 -->
                <el-button v-if="isSubscribeExamineCG && seeTemp.statue == 11 " type="success" style="display:inline-block" @click="handleExamine5(row)">审核5</el-button>


                <el-button v-if="isSubscribeExamineCW && seeTemp.purchase_type > 0 && seeTemp.statue == 5 " style="display:inline-block" type="success" size="mini" @click="handleExamine6(row)">审核6</el-button>


              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer" style="bottom:5px;">
          <el-button @click="dialogFormVisibleSee = false">关闭</el-button>
        </div>
      </div>
    </el-dialog>

    <!-- 审核 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible_Examine" :close-on-click-modal="false" width="30%">
      <div class="app-examine">
        <h3 style="width: 100%;margin:0 0 0 5%;line-height:50px;">请确认审核结果:</h3>
        <el-form ref="examineTemp" :rules="rules" :model="examineTemp" label-position="right" style="width: 50%;margin:0 auto;">
          <el-row style="width:88%;height:150px;margin:0 auto;">
            <el-col :span="20">
              <el-form-item>
                <el-radio-group v-model="examineTemp.statue" @change="changeStatue">
                  <el-radio :label="1" checked>通过</el-radio>
                  <el-radio :label="2">不通过</el-radio>
                </el-radio-group>
              </el-form-item>
            </el-col>
            <el-col v-if="statueReason" :span="20">
              <el-input v-model="examineTemp.workflowNote" type="textarea" :autosize="{ minRows: 2, maxRows: 4}" placeholder="请输入不通过原因" />
            </el-col>
          </el-row>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button v-if="dialogStatus==='examine1'" type="primary" :disabled="isokDisable" @click="createExamineData1()">确认</el-button>
        <el-button v-if="dialogStatus==='examine2'" type="primary" :disabled="isokDisable" @click="createExamineData2()">确认</el-button>
        <el-button v-if="dialogStatus==='examine3'" type="primary" :disabled="isokDisable" @click="createExamineData3()">确认</el-button>
        <el-button v-if="dialogStatus==='examine4'" type="primary" :disabled="isokDisable" @click="createExamineData4()">确认</el-button>
        <el-button v-if="dialogStatus==='examine5'" type="primary" :disabled="isokDisable" @click="createExamineData5()">确认</el-button>
        <el-button v-if="dialogStatus==='examine6'" type="primary" :disabled="isokDisable" @click="createExamineData6()">确认</el-button>
        <el-button @click="dialogFormVisible_Examine = false;">关闭</el-button>
      </div>
    </el-dialog>


  </div>
</template>

<script>
// / 引入
import { GetDataByName,postJson, GetDataByNames, partslistSGv2, PostDataByName, ExecDataByConfig, checkButtons, failproccess, GetAccount } from '@/api/common'
import waves from '@/directive/waves' // waves directive
import { parseTime, sortChange, json2excel } from '@/utils/index.js'
// eslint-disable-next-line no-unused-vars
import { validateEMail } from '@/utils/validate.js'
import Pagination from '@/components/Pagination' // secondary package based on el-pagination
import { MessageBox } from 'element-ui'
import Cookies from 'js-cookie'
import { getToken } from '@/utils/auth'
export default {
  name: 'Subscribe',
  components: { Pagination },
  directives: { waves },
  data() {
    return {
      isSubscribeAdd: [],isSubscribeSpecial:[], isSubscribeExamineSBZG:[],isSubscribeTemplate: [], isSubscribeImport: [], isSubscribeExport: [], isSubscribeSee: [], isSubscribeDelete: [], isSubscribeExamineKG: [], isSubscribeExamineCG: [],isSubscribeExamineCW:[], isSubscribeExamineZG: [],sdchangzhangshenhe: [],
      isokDisable: false,
      findAllProvider: [],
      findAllPasture: [],
      findAllDepart: [],
      findAllEmploye: [],
      subscriptionStatusList:[{id:0,name:'正常'},{id:1,name:'暂估'},{id:3,name:'赠品'}],//申购状态
      onlineSubscriptionList: [], createDepartList: [], edit: 0,
      requestParams: [
        { name: 'findAllProvider', offset: 0, pagecount: 0, params: [] },
        { name: 'findAllPasture', offset: 0, pagecount: 0, returntype: 'Map', parammaps: { 'id': Cookies.get('pastureid') }},
        { name: 'findAllEmploye', offset: 0, pagecount: 0, parammaps: { 'pastureId': Cookies.get('pastureid') }},
        { name: 'getflexProviderList', offset: 0, pagecount: 0, parammaps: {}}
      ],
      getDepartParam: {
        name: 'findAllDepart', offset: 0, pagecount: 0,
        parammaps: { 'pastureId': Cookies.get('pastureid'), 'eId': Cookies.get('employeid') }
      },
      pickerOptions: {
        disabledDate(time) {
          return time.getTime() > Date.now()// 当天之前的时间可选
        }
      },
      textMap: {
        update: '编辑',
        create: '新增',
        see: '查看/特殊申购l',
        examine1: '审核1',
        examine2: '审核2',
        examine3: '审核3',
        examine4: '审核4',
        examine5: '审核5',
        special: '特殊申购'
      },
      rules: {
        equipmentName: [{ required: true, message: '必填', trigger: 'blur' }]
      },
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      statues: [{ id: '0', name: '审核中' }, { id: '1', name: '已通过' }, { id: '2', name: '未通过' }],
      radioAll: '全部',
      getdataListParm: {
        name: 'getpartpurchaseList',
        page: 1,
        offset: 1,
        pagecount: 10,
        returntype: 'Map',
        parammaps: {
          pastureName: Cookies.get('pasturename'),
          empId: Cookies.get('employeid'),
          orderNumber: '',
          stuteSH: '',
          departmentId: '',
          inputDatetime: '',
          startTime: '',
          stopTime: '',
          loginId: Cookies.get('employeid'),
          menu: 'Subscribe',
          logindeptId: Cookies.get('departmentid'),
          loginpastureId: Cookies.get('pastureid'),
          purchase_type:''
        }
      },
      tableKey: 0,
      listLoading: true,
      total: 0,
      list: [],
      dialogStatus: '',
      dialogFormVisible: false,
      dialogFormVisibleSee: false,
      listLoadingSee: true,
      listSee: [],
      totalSee: 0,
      seeTemp: {},
      getdataListSee: {
        name: 'getpartpurchaseBybig',
        returntype: 'Map',
        parammaps: {}
      },
      createTemp: {
        pastureId: this.$store.state.user.pastureid,
        departmentId: this.$store.state.user.departmentid,
        employeId: this.$store.state.user.employeid,
        createTime: parseTime(new Date(), '{y}-{m}-{d}'),
        providerId: '',
        purchaseType:'1',
        funderId:''
      },
      requestSparePart: {
        name: 'getPartsListSG',
        page: 1,
        offset: 1,
        pagecount: 20,
        returntype: 'Map',
        parammaps: {
          pastureId: Cookies.get('pastureid')
        }
      },
      getParmCreateNumber: {
        name: 'autoCreatCode',
        page: 0,
        offset: 0,
        pagecount: 0,
        returntype: 'Map',
        parammaps: {
          pastureId: Cookies.get('pastureid'),
          codeType: 'SG'
        }
      },
      getParmCreateAmount: {
        name: 'getPartsListSGv2',
        page: 0,
        offset: 0,
        pagecount: 0,
        returntype: 'Map',
        parammaps: {
          pastureId: Cookies.get('pastureid'),
          pastureName: Cookies.get('pasturename')
        }
      },
      listAdd: [],
      postDataPramas: {},
      requestParam: {},
      dialogFormVisible_Examine: false,
      examineTemp: {
        statue: 1
      },
      statueReason: false,
      activeList: [],
      active: 3,
      buttons: [],
      downloadParam: {},
      isPercentage: false,
      percentage: 1,
      pending: {
        total: 0,
        getdataListParm: {
          name: 'getpartpurchaseWebListNO', page: 1, offset: 1, getTotal: 'total3', pagecount: 10, returntype: 'Map',
          parammaps: {
            loginId: Cookies.get('employeid'),
            menu: 'Subscribe', logindeptId: Cookies.get('departmentid'), loginpastureId: Cookies.get('pastureid'),
            empId: Cookies.get('employeid'), pastureId: Cookies.get('pastureid'), deptId: Cookies.get('departmentid')
          }
        }
      },
      providerList:[],
      myHeight:document.documentElement.clientHeight - 85- 150
    }
  },

  created() {
    const that = this
    GetDataByName({ 'name': 'getUserPCButtons', 'parammaps': { 'jwt_username': Cookies.get('name') }}).then(response => {
      that.buttons = response.data.list
      that.get_auto_buttons()
    })
    this.get_select_list()
    this.get_table_data()
    this.getPendingList()
    this.getProviderList()
  },

  methods: {
    tableSort(column) {
      sortChange(column, this.listSee)
    },
    get_auto_buttons() {
      // 新增
      const SubscribeAdd = 'customs:subscribe:add'
      const isSubscribeAdd = checkButtons(this.$store.state.user.buttons, SubscribeAdd)
      this.isSubscribeAdd = isSubscribeAdd
      // isSubscribeSpecial
      // 特殊申购
      const SubscribeSpecial = 'customs:subscribe:special'
      const isSubscribeSpecial = checkButtons(this.$store.state.user.buttons, SubscribeSpecial)
      this.isSubscribeSpecial = isSubscribeSpecial
      // 模板
      // eslint-disable-next-line no-redeclare
      const SubscribeTemplate = 'customs:subscribe:template'
      const isSubscribeTemplate = checkButtons(this.$store.state.user.buttons, SubscribeTemplate)
      this.isSubscribeTemplate = isSubscribeTemplate
      // 导入
      // eslint-disable-next-line no-redeclare
      const SubscribeImport = 'customs:subscribe:import'
      const isSubscribeImport = checkButtons(this.$store.state.user.buttons, SubscribeImport)
      this.isSubscribeImport = isSubscribeImport
      // 导出
      // eslint-disable-next-line no-redeclare
      const SubscribeExport = 'customs:subscribe:export'
      const isSubscribeExport = checkButtons(this.$store.state.user.buttons, SubscribeExport)
      this.isSubscribeExport = isSubscribeExport
      // 查看
      // eslint-disable-next-line no-redeclare
      const SubscribeSee = 'customs:subscribe:see'
      const isSubscribeSee = checkButtons(this.$store.state.user.buttons, SubscribeSee)
      this.isSubscribeSee = isSubscribeSee
      // 删除
      // eslint-disable-next-line no-redeclare
      const SubscribeDelete = 'customs:subscribe:delete'
      const isSubscribeDelete = checkButtons(this.$store.state.user.buttons, SubscribeDelete)
      this.isSubscribeDelete = isSubscribeDelete
      // 库管审核
      // eslint-disable-next-line no-redeclare
      const SubscribeExamineKG = 'customs:subscribe:examineKG'
      const isSubscribeExamineKG = checkButtons(this.$store.state.user.buttons, SubscribeExamineKG)
      this.isSubscribeExamineKG = isSubscribeExamineKG
// 设备主管审核
      const SubscribeExamineSBZG = 'customs:subscribe:examineSBZG'
      const isSubscribeExamineSBZG = checkButtons(this.$store.state.user.buttons, SubscribeExamineSBZG)
      this.isSubscribeExamineSBZG = isSubscribeExamineSBZG


      // 主管审核
      // eslint-disable-next-line no-redeclare
      const SubscribeExamineZG = 'customs:subscribe:examineZG'
      const isSubscribeExamineZG = checkButtons(this.$store.state.user.buttons, SubscribeExamineZG)
      this.isSubscribeExamineZG = isSubscribeExamineZG

      const changzhangshenhe = 'changzhangshenhe'
      const sdchangzhangshenhe = checkButtons(this.$store.state.user.buttons, changzhangshenhe)
      this.sdchangzhangshenhe = sdchangzhangshenhe
      // 采购审核
      // eslint-disable-next-line no-redeclare
      const SubscribeExamineCG = 'customs:subscribe:examineCG'
      const isSubscribeExamineCG = checkButtons(this.$store.state.user.buttons, SubscribeExamineCG)
      this.isSubscribeExamineCG = isSubscribeExamineCG

      // 财务审核
      const SubscribeExamineCW = 'customs:subscribe:examineCW'
      const isSubscribeExamineCW = checkButtons(this.$store.state.user.buttons, SubscribeExamineCW)
      this.isSubscribeExamineCW = isSubscribeExamineCW
    },
    getPendingList() {
      this.pending.getdataListParm.parammaps.pastureName = this.getdataListParm.parammaps.pastureName
      this.pending.getdataListParm.parammaps.orderNumber = this.getdataListParm.parammaps.orderNumber
      this.pending.getdataListParm.parammaps.stuteSH = this.getdataListParm.parammaps.stuteSH
      this.pending.getdataListParm.parammaps.departmentId = this.getdataListParm.parammaps.departmentId
      this.pending.getdataListParm.parammaps.inputDatetime = this.getdataListParm.parammaps.inputDatetime
      this.pending.getdataListParm.parammaps.loginId = this.getdataListParm.parammaps.loginId
      this.pending.getdataListParm.parammaps.menu = this.getdataListParm.parammaps.menu
      this.pending.getdataListParm.parammaps.logindeptId = this.getdataListParm.parammaps.logindeptId
      this.pending.getdataListParm.parammaps.loginpastureId = this.getdataListParm.parammaps.loginpastureId
      this.pending.getdataListParm.parammaps.empId = this.getdataListParm.parammaps.empId
      this.pending.getdataListParm.parammaps.pastureId = Cookies.get('pastureid')
      this.pending.getdataListParm.parammaps.deptId = Cookies.get('departmentid')
      GetDataByName(this.pending.getdataListParm).then(response => {
        this.pending.total = response.data.total3
      })
    },
    get_table_data() {
      this.listLoading = true
      if (this.$refs['inputDatetime'] !== undefined && this.$refs['inputDatetime'].value !== null) {
        this.getdataListParm.parammaps.startTime = this.$refs['inputDatetime'].value[0]
        this.getdataListParm.parammaps.stopTime = this.$refs['inputDatetime'].value[1]
      } else {
        this.getdataListParm.parammaps.startTime = ''
        this.getdataListParm.parammaps.stopTime = ''
      }
      GetDataByName(this.getdataListParm).then(response => {
        if (response.data.list !== null) {
          console.log('table数据', response.data.list)
          this.list = response.data.list
          this.pageNum = response.data.pageNum
          this.pageSize = response.data.pageSize
        } else {
          this.list = []
        }
        this.total = response.data.total

        setTimeout(() => {
          this.listLoading = false
        }, 100)
      })
    },
    changeAll() {
      console.log(this.radioAll)
      if (this.radioAll === '全部') {
        this.getdataListParm.name = 'getpartpurchaseList'
        this.getdataListParm.offset = 1
        this.getdataListParm.parammaps = {
          pastureName: Cookies.get('pasturename'),
          orderNumber: '',
          departmentId: '',
          inputDatetime: '',
          startTime: '',
          stopTime: '',
          loginId: Cookies.get('employeid'),
          menu: 'Subscribe',
          logindeptId: Cookies.get('departmentid'),
          loginpastureId: Cookies.get('pastureid')
        }
        this.get_table_data()
      } else if (this.radioAll === '待处理') {
        this.getdataListParm.name = 'getpartpurchaseWebListNO'
        this.getdataListParm.offset = 1
        this.getdataListParm.parammaps = {
          pastureName: this.getdataListParm.parammaps.pastureName,
          orderNumber: this.getdataListParm.parammaps.orderNumber,
          stuteSH: this.getdataListParm.parammaps.stuteSH,
          departmentId: this.getdataListParm.parammaps.departmentId,
          inputDatetime: this.getdataListParm.parammaps.inputDatetime,
          startTime: this.getdataListParm.parammaps.startTime,
          stopTime: this.getdataListParm.parammaps.stopTime,
          loginId: Cookies.get('employeid'),
          menu: 'Subscribe',
          logindeptId: Cookies.get('departmentid'),
          loginpastureId: Cookies.get('pastureid'),
          empId: Cookies.get('employeid'),
          pastureId: Cookies.get('pastureid'),
          deptId: Cookies.get('departmentid')
        }
        this.get_table_data()
      } else if (this.radioAll === '已处理') {
        this.getdataListParm.name = 'getpartpurchaseWebList'
        this.getdataListParm.offset = 1
        this.getdataListParm.parammaps = {
          pastureName: this.getdataListParm.parammaps.pastureName,
          orderNumber: this.getdataListParm.parammaps.orderNumber,
          stuteSH: this.getdataListParm.parammaps.stuteSH,
          departmentId: this.getdataListParm.parammaps.departmentId,
          inputDatetime: this.getdataListParm.parammaps.inputDatetime,
          startTime: this.getdataListParm.parammaps.startTime,
          stopTime: this.getdataListParm.parammaps.stopTime,
          loginId: Cookies.get('employeid'),
          menu: 'Subscribe',
          logindeptId: Cookies.get('departmentid'),
          loginpastureId: Cookies.get('pastureid'),
          empId: Cookies.get('employeid'),
          pastureId: Cookies.get('pastureid'),
          deptId: Cookies.get('departmentid')
        }
        this.get_table_data()
      }
    },
    statue: function(cellValue) {
      // console.log(cellValue.isZeroStock)
      if (cellValue.statue == 2) {
        return '审核中'
      } else if (cellValue.statue == 3) {
        return '审核中'
      } else if (cellValue.statue == 4) {
        return '未通过'
      } else if (cellValue.statue == 5) {
        return '审核中'
      } else if (cellValue.statue == 6) {
        return '未通过'
      } else if (cellValue.statue == 7) {
        return '已通过'
      } else if (cellValue.statue == 8) {
        return '未通过'
      } else if (cellValue.statue == 9) {
        return '审核中'
      } else if (cellValue.statue == 10) {
        return '未通过'
      } else if (cellValue.statue == 11) {
        return '审核中'
      } else if (cellValue.statue == 12) {
        return '未通过'
      } else if (cellValue.statue == 13) {
        return '审核中'
      } else if (cellValue.statue == 14) {
        return '未通过'
      }
    },
    form_search() {
      console.log('点击了table搜索')
      if (this.getdataListParm.parammaps.inputDatetime === null) {
        this.getdataListParm.parammaps.inputDatetime = ''
      }
      this.getdataListParm.offset = 1
      this.listLoading = true
      this.get_table_data()
      this.getPendingList()
    },
    resetCreateTemp() {
      this.createTemp.pastureId = parseInt(Cookies.get('pastureid'))
      this.createTemp.departmentId = parseInt(Cookies.get('departmentid'))
      this.createTemp.departmentName = Cookies.get('departmentname')
      this.createTemp.employeId = parseInt(Cookies.get('employeid'))
      this.createTemp.createTime = parseTime(new Date(), '{y}-{m}-{d}')
      this.createTemp.orderNumber = ''
      this.createTemp.providerId = ''
      this.createTemp.funderId = ''
      this.createTemp.purchaseType = '1'
      this.listAdd = []
    },
    form_add() {
      this.resetCreateTemp()
      this.edit = 1
      this.getDepartParam.parammaps.pastureId = this.createTemp.pastureId
      this.getCreateDepartDownList()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['createTemp'].clearValidate()
      })
      this.getCreateNumber()
    },
    getCreateNumber() {
      GetDataByName(this.getParmCreateNumber).then(response => {
        this.$nextTick(() => {
          console.log('新增申购单号', response.data.list[0].orderCode)
          this.createTemp.orderNumber = response.data.list[0].orderCode
          this.$forceUpdate()
        })
      })
    },
    // getPartsListSG
    changeProvider(item) {
      if (item !== '') {
        this.createTemp.providerName = this.onlineSubscriptionList.find(obj => obj.id == item).providerName
      }
      this.listAdd = []
    },
    sparePartSearch(queryString, cb) {
      console.log('备件模糊查询输入值', queryString)
      if(this.dialogStatus==='special'){
        if(this.createTemp.purchaseType == 1 || this.createTemp.purchaseType == '3'){
          if(this.createTemp.providerId == ''){
            this.$message({ type: 'warning', message: '请选择供应商' })
            return false;
          }else{
            if(this.createTemp.purchaseType == '3'){
              this.requestSparePart.name = 'getStockListByGiveaway'
              this.requestSparePart.parammaps['providerName'] = this.providerList.find(obj => obj.id == this.createTemp.providerId).providerName
              this.requestSparePart.parammaps['providerId'] = this.createTemp.providerId
              this.requestSparePart.parammaps['pastureId'] = this.createTemp.pastureId
            }else{
              this.requestSparePart.name = 'getPartsListSG'
              this.requestSparePart.parammaps['providerId'] = this.createTemp.providerId
            }
          }
        }
      }else{
        if (this.createTemp.providerId == '') {
          this.requestSparePart.name = 'getPartsListSG'
        } else {
          this.requestSparePart.name = 'getPartsListSGFlex'
          this.requestSparePart.parammaps.providerId = this.createTemp.providerId
          this.requestSparePart.parammaps.providerName = this.createTemp.providerName
        }
      }
      this.requestSparePart.parammaps['partCode'] = queryString
      GetDataByName(this.requestSparePart).then(response => {
        console.log('备件模糊查询搜索data', response.data.list)
        if (response.data.list == null) {
          cb([])
        } else {
          cb(response.data.list)
        }
      })
    },
    handleSelectSparePart(item) {
      console.log('备件模糊查询选中值', item)
      console.log('备件模糊查询选中值', item.partId)
      console.log(this.listAdd)
      if(this.dialogStatus==='special' && this.createTemp.purchaseType == '1' && this.createTemp.providerId == ''){
        this.createTemp.providerId = item.providerId
      }
      if (this.createTemp.providerId == '') {
        if (this.listAdd.length > 0) {
          if (this.listAdd.find(obj => obj.partId == item.partId)) {
            this.$message({ type: 'warning', message: '此备件已存在，请重新选择备件' })
          } else {
            this.getParmCreateAmount.parammaps.partCode = item.partCode
            partslistSGv2(this.getParmCreateAmount).then(response => {
              this.$nextTick(() => {
                console.log('新增根据编号获取备件库存数量', response.data.list[0])
                item = response.data.list[0]
                if (item.srcpath !== null && item.picpath !== null && item.srcpath !== undefined && item.picpath !== undefined) {
                  this.$set(item, 'srcpath', process.env.VUE_APP_BASE_API + item.srcpath)
                  this.$set(item, 'picpath', process.env.VUE_APP_BASE_API + item.picpath)
                } else {
                  item.srcpath = ''
                  item.picpath = ''
                }
                this.$set(item, 'amount', '')
                this.$set(item, 'purpose', '')
                if(this.dialogStatus==='special' && this.createTemp.purchaseType == '2'){
                  this.$set(item,'price','')
                }else if(this.dialogStatus==='special' && this.createTemp.purchaseType == '3'){
                  this.$set(item,'price','0')
                  this.$set(item,'amount','0')
                }
                this.listAdd.unshift(item)
                this.$forceUpdate()
              })
            })
          }
        } else {
          this.getParmCreateAmount.parammaps.partCode = item.partCode
          partslistSGv2(this.getParmCreateAmount).then(response => {
            this.$nextTick(() => {
              console.log('新增根据编号获取备件库存数量', response.data.list[0])
              item = response.data.list[0]
              if (item.srcpath !== null && item.picpath !== null && item.srcpath !== undefined && item.picpath !== undefined) {
                this.$set(item, 'srcpath', process.env.VUE_APP_BASE_API + item.srcpath)
                this.$set(item, 'picpath', process.env.VUE_APP_BASE_API + item.picpath)
              } else {
                item.srcpath = ''
                item.picpath = ''
              }
              this.$set(item, 'amount', '')
              this.$set(item, 'purpose', '')
              if(this.dialogStatus==='special' && this.createTemp.purchaseType == '2'){
                this.$set(item,'price','')
              }else if(this.dialogStatus==='special' && this.createTemp.purchaseType == '3'){
                this.$set(item,'price','0')
                this.$set(item,'amount','0')
              }
              this.listAdd.unshift(item)
              this.$forceUpdate()
            })
          })
        }
        this.$forceUpdate()
      } else {
        if (this.listAdd.length > 0) {
          if (this.listAdd.find(obj => obj.partId == item.partId)) {
            this.$message({ type: 'warning', message: '此备件已存在，请重新选择备件' })
          } else {
            if (item.srcpath !== null && item.picpath !== null && item.srcpath !== undefined && item.picpath !== undefined) {
              this.$set(item, 'srcpath', process.env.VUE_APP_BASE_API + item.srcpath)
              this.$set(item, 'picpath', process.env.VUE_APP_BASE_API + item.picpath)
            } else {
              item.srcpath = ''
              item.picpath = ''
            }
            this.$set(item, 'amount', '')
            this.$set(item, 'purpose', '')
            if(this.dialogStatus==='special' && this.createTemp.purchaseType == '3'){
              this.$set(item,'price','0')
              this.$set(item,'amount','0')
            }
            this.listAdd.unshift(item)
          }
        } else {
          if (item.srcpath !== null && item.picpath !== null && item.srcpath !== undefined && item.picpath !== undefined) {
            this.$set(item, 'srcpath', process.env.VUE_APP_BASE_API + item.srcpath)
            this.$set(item, 'picpath', process.env.VUE_APP_BASE_API + item.picpath)
          } else {
            item.srcpath = ''
            item.picpath = ''
          }
          this.$set(item, 'amount', '')
          this.$set(item, 'purpose', '')
          if(this.dialogStatus==='special' && this.createTemp.purchaseType == '3'){
            this.$set(item,'price','0')
            this.$set(item,'amount','0')
          }
          this.listAdd.unshift(item)
          this.$forceUpdate()
        }
        this.$forceUpdate()
      }
      console.log(this.listAdd,'this.listAdd')
    },
    add_dialog_save() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          console.log(this.listAdd)
          if (this.createTemp.orderNumber == '' || this.createTemp.orderNumber == null || this.createTemp.orderNumber == undefined) {
            GetDataByName(this.getParmCreateNumber).then(response => {
              this.$nextTick(() => {
                console.log('新增申购单号', response.data.list[0].orderCode)
                this.createTemp.orderNumber = response.data.list[0].orderCode
                this.$forceUpdate()
                this.add_dialog_saveSave()
              })
            })
          } else {
            this.add_dialog_saveSave()
          }
        }
      })
    },
    add_dialog_saveSave() {
      if (this.listAdd.length !== 0) {
        for (var j = 0; j < this.listAdd.length; j++) {
          console.log(this.listAdd[j].amount)
          if (this.listAdd[j].amount == null || this.listAdd[j].amount === '') {
            this.$message({ type: 'warning', message: '请检查申购数量是否未填写', duration: 2000 })
            return false
          } else {
            var rulesAmount = /^[1-9]\d*$/
            if (!rulesAmount.test(this.listAdd[j].amount)) {
              this.$message({ type: 'error', message: '申购数量请输入正整数', duration: 2000 })
              return false
            }
          }
          if (this.createTemp.providerId !== '') {
            if (this.listAdd[j].price == '') {
              this.$message({ type: 'warning', message: '请检查单价是否为空', duration: 2000 })
              return false
            } else {
              if (parseFloat(this.listAdd[j].price) == 0) {
                this.$message({ type: 'warning', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                return false
              } else {
                var rulesPrice = /^(([1-9]{1}\d*)|(0{1}))(\.\d{1,2})?$/
                if (rulesPrice.test(this.listAdd[j].price) == false) {
                  this.$message({ type: 'error', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                  return false
                }
              }
            }
          }
        }
        this.postDataPramas.common = { 'returnmap': '0' }
        this.postDataPramas.data = []
        this.postDataPramas.data[0] = { 'name': 'insertBigPartpurchase', 'type': 'e', 'parammaps': {
          pastureId: this.createTemp.pastureId,
          departmentId: this.createTemp.departmentId,
          orderNumber: this.createTemp.orderNumber,
          useType: this.createTemp.useType,
          createTime: this.createTemp.createTime,
          employeId: this.createTemp.employeId,
          providerId: this.createTemp.providerId
        }}
        // eslint-disable-next-line no-irregular-whitespace
        this.postDataPramas.data[1] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.listAdd }}
        this.postDataPramas.data[1].children = []
        this.postDataPramas.data[1].children[0] = { 'name': 'insertPartpurchase', 'type': 'e', 'parammaps': {
          bigId: '@insertBigPartpurchase.LastInsertId',
          pastureId: '@insertSpotList.pastureId',
          partId: '@insertSpotList.partId',
          partCode: '@insertSpotList.partCode',
          partName: '@insertSpotList.partName',
          specification: '@insertSpotList.specification',
          unit: '@insertSpotList.unit',
          brandId: '@insertSpotList.brandId',
          storageAmount: '@insertSpotList.reportery',
          purpose: '@insertSpotList.purpose',
          amount: '@insertSpotList.amount',
          price: '@insertSpotList.price',
          contractId: '@insertSpotList.contractId'
        }}
        ExecDataByConfig(this.postDataPramas).then(response => {
          console.log('新增保存发送参数', this.postDataPramas)
          if (response.msg === 'fail') {
            this.$notify({
              title: '保存失败',
              message: response.data,
              type: 'warning',
              duration: 2000
            })
          } else {
            this.dialogFormVisible = false
            this.getdataListParm.parammaps.inputDatetime = ''
            this.get_table_data()
            this.getPendingList()
            this.$notify({
              title: '',
              message: '保存成功',
              type: 'success',
              duration: 2000
            })
          }
        })
        return true
      } else {
        this.$message({
          title: '',
          message: '请选择备件',
          type: 'warning',
          duration: 2000
        })
        return false
      }
    },
    partDelete(row) {
      console.log(this.listAdd)
      MessageBox.confirm('设备名称：' + row.partName, '确认删除？', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // console.log(this.list2)
        for (var i = 0; i < this.listAdd.length; i++) {
          console.log(this.listAdd[i])
          if (this.listAdd[i].id === row.id) {
            var listAddIndex = this.listAdd.indexOf(this.listAdd[i])
          }
          if (listAddIndex > -1) {
            this.listAdd.splice(listAddIndex, 1)
            return
          }
        }
      })
    },
    // 查看
    form_see(row) {
      this.dialogStatus = 'see'
      this.dialogFormVisibleSee = true
      this.seeTemp = Object.assign({}, row)
      this.seeTemp.purchaseType = String(row.purchase_type)
      console.log('查看上方数据(从table读取)', this.seeTemp)
      this.listSee = []
      this.getdataListSee.parammaps.id = this.seeTemp.id
      this.getSeeList()
      // 流程图
      var reason = '未通过原因:' + this.seeTemp.workflowNote



      if (this.seeTemp.purchase_type < 0 || this.seeTemp.purchase_type == 0 ) {
          if (this.seeTemp.statue === 2) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核' },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '场长审核' },{ title: '采购审核' }]
            this.active = 1
          } else if (this.seeTemp.statue === 3) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '场长审核' }, { title: '采购审核' }]
            this.active = 2
          } else if (this.seeTemp.statue === 4) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson, status: 'error', reason: reason },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '场长审核' },{ title: '采购审核' }]
            this.active = 2
          } else if (this.seeTemp.statue === 9) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson },{ title: '供应主管审核' }, { title: '场长审核' },{ title: '采购审核' }]
            this.active = 3
          } else if (this.seeTemp.statue === 10) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson, status: 'error', reason: reason  }, { title: '供应主管审核' }, { title: '场长审核' },{ title: '采购审核' }]
            this.active = 3
          }  else if (this.seeTemp.statue === 5) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson   }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson }, { title: '场长审核' }, { title: '采购审核' }]
            this.active = 4
          } else if (this.seeTemp.statue === 6) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson, status: 'error', reason: reason }, { title: '场长审核' }, { title: '采购审核' }]
            this.active = 4
          }  else if (this.seeTemp.statue === 11) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson   }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson }, { title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson }, { title: '采购审核' }]
            this.active = 5
          } else if (this.seeTemp.statue === 12) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson  }, { title: '场长审核' , date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson, status: 'error', reason: reason }, { title: '采购审核' }]
            this.active = 5

          } else if (this.seeTemp.statue === 7) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson }, { title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson }, { title: '采购审核', date: this.seeTemp.CGChargedate, name: this.seeTemp.CGChargePerson }]
            this.active = 6
          } else if (this.seeTemp.statue === 8) {
            this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson }, { title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson },{ title: '采购审核', date: this.seeTemp.CGChargedate, name: this.seeTemp.CGChargePerson, status: 'error', reason: reason }]
            this.active = 6
          }
      } else if(this.seeTemp.purchase_type == 3){
        this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }]
        this.active = 1
      }else {
        // 待写
        if (this.seeTemp.statue === 2) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核' },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '财务审核' },{ title: '场长审核' },{ title: '采购审核' }]
          this.active = 1
        } else if (this.seeTemp.statue === 3) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '财务审核' }, { title: '场长审核' }, { title: '采购审核' }]
          this.active = 2
        } else if (this.seeTemp.statue === 4) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson, status: 'error', reason: reason },{ title: '设备主管审核' }, { title: '供应主管审核' }, { title: '财务审核' }, { title: '场长审核' },{ title: '采购审核' }]
          this.active = 2
        } else if (this.seeTemp.statue === 9) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson },{ title: '供应主管审核' },  { title: '财务审核' },{ title: '场长审核' },{ title: '采购审核' }]
          this.active = 3
        } else if (this.seeTemp.statue === 10) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson, status: 'error', reason: reason  }, { title: '供应主管审核' }, { title: '财务审核' }, { title: '场长审核' },{ title: '采购审核' }]
          this.active = 3
        }  else if (this.seeTemp.statue === 5) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson   }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson },  { title: '财务审核' },{ title: '场长审核' }, { title: '采购审核' }]
          this.active = 4
        } else if (this.seeTemp.statue === 6) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson, status: 'error', reason: reason },  { title: '财务审核' },{ title: '场长审核' }, { title: '采购审核' }]
          this.active = 4
        } else if (this.seeTemp.statue === 13) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson   }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson },  { title: '财务审核', date: this.seeTemp.financedate, name: this.seeTemp.financeName },{ title: '场长审核',}, { title: '采购审核' }]
          this.active = 5
        } else if (this.seeTemp.statue === 14) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson  },  { title: '财务审核',date: this.seeTemp.financedate, name: this.seeTemp.financeName, status: 'error', reason: reason },{ title: '场长审核' }, { title: '采购审核' }]
          this.active = 5
        }  else if (this.seeTemp.statue === 11) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson   }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson },  { title: '财务审核', date: this.seeTemp.financedate, name: this.seeTemp.financeName },{ title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson }, { title: '采购审核' }]
          this.active = 6
        } else if (this.seeTemp.statue === 12) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson },  { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson  },  { title: '财务审核', date: this.seeTemp.financedate, name: this.seeTemp.financeName },{ title: '场长审核' , date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson, status: 'error', reason: reason }, { title: '采购审核' }]
          this.active = 6
        } else if (this.seeTemp.statue === 7) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson }, { title: '财务审核', date: this.seeTemp.financedate, name: this.seeTemp.financeName }, { title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson }, { title: '采购审核', date: this.seeTemp.CGChargedate, name: this.seeTemp.CGChargePerson }]
          this.active = 7
        } else if (this.seeTemp.statue === 8) {
          this.activeList = [{ title: '备件申购', date: this.seeTemp.inputTime, name: this.seeTemp.empname }, { title: '库管审核', date: this.seeTemp.KGChargedate, name: this.seeTemp.KGChargePerson }, { title: '设备主管审核', date: this.seeTemp.equipmentdate, name: this.seeTemp.equipmentPerson }, { title: '供应主管审核', date: this.seeTemp.chargeDate, name: this.seeTemp.chargePerson },  { title: '财务审核', date: this.seeTemp.financedate, name: this.seeTemp.financeName },{ title: '场长审核', date: this.seeTemp.fielddate, name: this.seeTemp.fieldPerson },{ title: '采购审核', date: this.seeTemp.CGChargedate, name: this.seeTemp.CGChargePerson, status: 'error', reason: reason }]
          this.active = 7
        }
      }


    },
    getSeeList() {
      GetDataByName(this.getdataListSee).then(response => {
        if (response.data.list !== null) {
          console.log('查看下方table数据', response.data.list)
          this.listSee = response.data.list
          this.listAdd = response.data.list
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].srcpath !== null && response.data.list[i].picpath !== null && response.data.list[i].srcpath !== undefined && response.data.list[i].picpath !== undefined) {
              console.log(process.env.VUE_APP_BASE_API + response.data.list[i].srcpath, '=======1')
              this.listSee[i].srcpath = process.env.VUE_APP_BASE_API + response.data.list[i].srcpath
              this.listSee[i].picpath = process.env.VUE_APP_BASE_API + response.data.list[i].picpath
              this.listAdd[i].srcpath = this.listSee[i].srcpath
              this.listAdd[i].picpath = this.listSee[i].picpath
              // this.seeTemp.providerName = response.data.list.providerName
              this.pageNumSee = response.data.pageNum
              this.pageSizeSee = response.data.pageSize
            } else {
              this.listSee[i].srcpath = ''
              this.listSee[i].picpath = ''
              this.listAdd[i].srcpath = ''
              this.listAdd[i].picpath = ''
            }
            console.log(process.env.VUE_APP_BASE_API)
            console.log(this.listSee, '============')
          }
        }
        if (response.data.total) {
          this.totalSee = response.data.total
        }
        setTimeout(() => {
          this.listLoadingSee = false
        }, 100)
      })
    },
    form_edit(row) {
      this.edit = 0
      this.getDepartParam.parammaps.pastureId = row.pastureId
      this.getCreateDepartDownList()
      if (row.providerId == undefined) {
        row.providerId = ''
        row.providerName = ''
      }
      this.createTemp = Object.assign({}, row) // copy obj
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['createTemp'].clearValidate()
      })
      this.getdataListSee.parammaps.id = this.createTemp.id
      this.getSeeList()
    },
    edit_dialog_save() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.edit_dialog_saveSave()
        }
      })
    },
    edit_dialog_saveSave() {
      if (this.listAdd.length !== 0) {
        for (var j = 0; j < this.listAdd.length; j++) {
          console.log(this.listAdd[j].amount)
          // eslint-disable-next-line use-isnan
          if (this.listAdd[j].amount == null || this.listAdd[j].amount === '') {
            this.$message({ type: 'warning', message: '请检查申购数量是否未填写', duration: 2000 })
            return false
          } else {
            var rulesAmount = /^[1-9]\d*$/
            if (!rulesAmount.test(this.listAdd[j].amount)) {
              this.$message({ type: 'error', message: '申购数量请输入正整数', duration: 2000 })
              return false
            }
          }
          if (this.createTemp.providerId !== '') {
            if (this.listAdd[j].price == '') {
              this.$message({ type: 'warning', message: '请检查单价是否为空', duration: 2000 })
              return false
            } else {
              if (parseFloat(this.listAdd[j].price) == 0) {
                this.$message({ type: 'warning', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                return false
              } else {
                var rulesPrice = /^(([1-9]{1}\d*)|(0{1}))(\.\d{1,2})?$/
                if (rulesPrice.test(this.listAdd[j].price) == false) {
                  this.$message({ type: 'error', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                  return false
                }
              }
            }
          }
        }
        this.postDataPramas.common = { 'returnmap': '0' }
        this.postDataPramas.data = []
        this.postDataPramas.data[0] = { 'name': 'updatepartpurchaseCharge', 'type': 'e', 'parammaps': {
          id: this.createTemp.id
        }}
        this.postDataPramas.data[1] = { 'name': 'deletePartpurchase', 'type': 'e', 'parammaps': {
          bigId: this.createTemp.id
        }}
        // eslint-disable-next-line no-irregular-whitespace
        this.postDataPramas.data[2] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.listAdd }}
        this.postDataPramas.data[2].children = []
        this.postDataPramas.data[2].children[0] = { 'name': 'insertPartpurchase', 'type': 'e', 'parammaps': {
          bigId: this.createTemp.id,
          pastureId: '@insertSpotList.pastureId',
          partId: '@insertSpotList.partId',
          partCode: '@insertSpotList.partCode',
          partName: '@insertSpotList.partName',
          specification: '@insertSpotList.specification',
          unit: '@insertSpotList.unit',
          brandId: '@insertSpotList.brandId',
          storageAmount: '@insertSpotList.reportery',
          purpose: '@insertSpotList.purpose',
          amount: '@insertSpotList.amount',
          price: '@insertSpotList.price',
          contractId: '@insertSpotList.contractId'
        }}
        ExecDataByConfig(this.postDataPramas).then(response => {
          console.log('新增保存发送参数', this.postDataPramas)
          if (response.msg === 'fail') {
            this.$notify({
              title: '保存失败',
              message: response.data,
              type: 'warning',
              duration: 2000
            })
          } else {
            this.dialogFormVisible = false
            this.getdataListParm.parammaps.inputDatetime = ''
            this.get_table_data()
            this.$notify({
              title: '',
              message: '保存成功',
              type: 'success',
              duration: 2000
            })
          }
        })
        return true
      } else {
        this.$message({
          title: '',
          message: '请选择备件',
          type: 'warning',
          duration: 2000
        })
        return false
      }
    },
    get_select_list() {
      GetDataByNames(this.requestParams).then(response => {
        this.findAllProvider = response.data.findAllProvider.list
        this.findAllPasture = response.data.findAllPasture.list
        this.findAllEmploye = response.data.findAllEmploye.list
        this.onlineSubscriptionList = response.data.getflexProviderList.list
        this.getDepartDownList()
      })
    },
    getDepartDownList() {
      GetDataByName(this.getDepartParam).then(response => {
        this.findAllDepart = response.data.list
      })
    },
    changePastureName(item) {
      this.getDepartParam.parammaps.pastureId = this.findAllPasture.find(obj => obj.name == item).id
      this.getdataListParm.parammaps.departmentId = ''
      this.getDepartDownList()
    },
    getCreateDepartDownList() {
      GetDataByName(this.getDepartParam).then(response => {
        this.createDepartList = response.data.list
        if (this.edit == 1) {
          if (this.createDepartList.find(obj => obj.id == Cookies.get('departmentid'))) {
            this.createTemp.departmentId = parseInt(Cookies.get('departmentid'))
            this.createTemp.departmentName = this.createDepartList.find(obj => obj.id == Cookies.get('departmentid')).name
          } else {
            this.createTemp.departmentId = response.data.list[0].id
            this.createTemp.departmentName = response.data.list[0].name
          }
        }
      })
    },
    changePasture(item) {
      this.getDepartParam.parammaps.pastureId = item
      this.edit = 1
      this.getCreateDepartDownList()
    },
    changeDepart(item) {
      this.createTemp.departmentName = this.createDepartList.find(obj => obj.id == item).name
    },
    handleDownload() {
      console.log('点击了下载')
      this.$alert('备件申购正在导出中，请勿刷新或离开本页面，若导出时间过长，建议缩小导出数据范围重新导出', {})
      this.isPercentage = true
      this.percentage = 1
      var timer = setInterval(() => {
        this.percentage += 5
        if (this.percentage > 95) {
          this.percentage = 99
          clearInterval(timer)
        }
        this.percentage = this.percentage
      }, 1000)
      this.downloadParam.name = 'downloadPartpurchaseList'
      this.downloadParam.parammaps = this.getdataListParm.parammaps
      GetAccount(this.downloadParam).then(response => {
        if (response.data.list !== '') {
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
        }
        this.$nextTick(() => {
          const ExcelDatas = [
            {
              tHeader: ['牧场', '申购单号', '申购时间', '备件编号', '备件名称', '规格型号', '品牌', '单位', '申购数量', '申购部门', '申购人', '备注'],
              filterVal: ['pastureName', 'orderNumber', 'inputTime', 'partCode', 'partName', 'specification', 'brandName', 'unit', 'amount', 'departmentName', 'empname', 'purpose'],
              tableDatas: response.data.list,
              sheetName: '备件申购'
            }
          ]
          json2excel(ExcelDatas, '备件申购', true, 'xlsx')
        })
      })
    },
    form_delete(row) {
      console.log('点击了删除')
      MessageBox.confirm('确认删除此条信息？', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.postDataPramas.common = { 'returnmap': '0' }
        this.postDataPramas.data = []
        this.postDataPramas.data[0] = { 'name': 'deleteBigPartpurchase', 'type': 'e', 'parammaps': {
          id: row.id
        }}
        this.postDataPramas.data[1] = { 'name': 'deletePartpurchase', 'type': 'e', 'parammaps': {
          bigId: row.id
        }}
        ExecDataByConfig(this.postDataPramas).then(response => {
          this.get_table_data()
          this.$notify({
            title: '成功',
            message: '删除成功',
            type: 'success',
            duration: 2000
          })
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    handleExamine1(row) {
      console.log('点击了库管审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'statue', 1)
        this.$set(this.examineTemp, 'workflowNote', '')
      }
      this.dialogStatus = 'examine1'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    changeStatue(val) {
      if (val == 2) {
        this.statueReason = true
      } else {
        this.statueReason = false
      }
    },
    createExamineData1() {
      console.log('点击了库管审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.name = 'partpurchaseCharge'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.id = this.examineTemp.id
          if (this.examineTemp.statue == 1) {
            this.requestParam.parammaps.statue = 3
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.parammaps.statue = 4
          }
          this.requestParam.parammaps.empId	 = Cookies.get('employeid')
          this.requestParam.parammaps.workflowNote = this.examineTemp.workflowNote
          PostDataByName(this.requestParam).then(response => {
            console.log('审核确认发送参数', this.requestParam)
            this.isokDisable = false
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({
                title: '成功',
                message: '审核成功',
                type: 'success',
                duration: 2000
              })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },

    handleExamine2(row) {
      console.log('点击了设备主管审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'statue', 1)
        this.$set(this.examineTemp, 'workflowNote', '')
      }
      this.dialogStatus = 'examine2'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    createExamineData2() {
      console.log('点击了设备主管审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.name = 'partpurchaseEquipment'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.id = this.examineTemp.id
          if (this.examineTemp.statue == 1) {
            this.requestParam.parammaps.statue = 9
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.parammaps.statue = 10
          }
          this.requestParam.parammaps.empId	 = Cookies.get('employeid')
          this.requestParam.parammaps.workflowNote = this.examineTemp.workflowNote
          PostDataByName(this.requestParam).then(response => {
            this.isokDisable = false
            console.log('审核确认发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({
                title: '成功',
                message: '审核成功',
                type: 'success',
                duration: 2000
              })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },
    handleExamine3(row) {
      console.log('点击了供应主管审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'statue', 1)
        this.$set(this.examineTemp, 'workflowNote', '')
      }
      this.dialogStatus = 'examine3'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    createExamineData3() {
      console.log('点击了供应主管审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.name = 'partpurchaseCharge3'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.id = this.examineTemp.id
          if (this.examineTemp.statue == 1) {
            this.requestParam.parammaps.statue = 5
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.parammaps.statue = 6
          }
          this.requestParam.parammaps.empId	 = Cookies.get('employeid')
          this.requestParam.parammaps.workflowNote = this.examineTemp.workflowNote
          PostDataByName(this.requestParam).then(response => {
            console.log('审核确认发送参数', this.requestParam)
            this.isokDisable = false
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({
                title: '成功',
                message: '审核成功',
                type: 'success',
                duration: 2000
              })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },
    handleExamine4(row) {
      console.log('点击了场长审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'workflowNote', '')
        this.$set(this.examineTemp, 'statue', 1)
      }
      this.dialogStatus = 'examine4'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    createExamineData4() {
      console.log('点击了场长审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.parammaps = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          // 通过
          if (this.examineTemp.statue == 1) {
            this.requestParam.data[0] = { 'name': 'partpurchaseField', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              statue: 11,
              field: Cookies.get('employeid'),
              workflowNote: this.examineTemp.workflowNote
            }}
            this.requestParam.data[1] = { 'name': 'createBuydetailBySG', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              pastureId: this.examineTemp.pastureId
            }}
          //不通过
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.data[0] = { 'name': 'partpurchaseField', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              statue: 12,
              field: Cookies.get('employeid'),
              workflowNote: this.examineTemp.workflowNote
            }}
          }
          ExecDataByConfig(this.requestParam).then(response => {
            this.isokDisable = false
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({ title: '成功', message: '审核成功', type: 'success', duration: 2000 })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },
    handleExamine5(row) {
      console.log('点击了采购审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'workflowNote', '')
        this.$set(this.examineTemp, 'statue', 1)
      }
      this.dialogStatus = 'examine5'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    createExamineData5() {
      console.log('点击了采购审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 10000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.parammaps = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          if (this.examineTemp.statue == 1) {
            this.requestParam.data[0] = { 'name': 'partpurchaseCharge1', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              statue: 7,
              empId: Cookies.get('employeid'),
              workflowNote: this.examineTemp.workflowNote
            }}
            this.requestParam.data[1] = { 'name': 'createBuydetailBySG', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              pastureId: this.examineTemp.pastureId
            }}
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.data[0] = { 'name': 'partpurchaseCharge1', 'type': 'e', 'parammaps': {
              id: this.examineTemp.id,
              statue: 8,
              empId: Cookies.get('employeid'),
              workflowNote: this.examineTemp.workflowNote
            }}
          }
          ExecDataByConfig(this.requestParam).then(response => {
            this.isokDisable = false
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({ title: '成功', message: '审核成功', type: 'success', duration: 2000 })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },
    handleExamine6(row) {
      console.log('点击了财务审核')
      if (row == undefined) {
        this.examineTemp = this.seeTemp
        this.$set(this.seeTemp, 'statue', 1)
        this.$set(this.seeTemp, 'workflowNote', '')
      } else {
        this.examineTemp = Object.assign({}, row)
        this.$set(this.examineTemp, 'workflowNote', '')
        this.$set(this.examineTemp, 'statue', 1)
      }
      this.dialogStatus = 'examine6'
      this.dialogFormVisible_Examine = true
      this.statueReason = false
    },
    createExamineData6() {
      console.log('点击了财务审核')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 10000)
      this.$refs['examineTemp'].validate(valid => {
        if (valid) {
          this.requestParam = {}
          this.requestParam.name = 'partpurchaseFinanceId'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.id = this.examineTemp.id
          if (this.examineTemp.statue == 1) {
            this.requestParam.parammaps.statue = 13
          } else if (this.examineTemp.statue == 2) {
            this.requestParam.parammaps.statue = 14
          }
          this.requestParam.parammaps.financeId	 = Cookies.get('employeid')
          this.requestParam.parammaps.workflowNote = this.examineTemp.workflowNote
          PostDataByName(this.requestParam).then(response => {
            console.log('审核确认发送参数', this.requestParam)
            this.isokDisable = false
            if (response.msg !== 'fail') {
              this.get_table_data()
              this.dialogFormVisible_Examine = false
              this.dialogFormVisible_See = false
              this.statueReason = false
              this.$notify({
                title: '成功',
                message: '审核成功',
                type: 'success',
                duration: 2000
              })
            } else {
              failproccess(response, this.$notify)
            }
          })
        }
      })
    },
    handle_specialSubscription(){
      this.resetCreateTemp()
      this.edit = 1
      this.getDepartParam.parammaps.pastureId = this.createTemp.pastureId
      this.getCreateDepartDownList()
      this.dialogStatus = 'special'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['createTemp'].clearValidate()
      })
      this.getCreateNumber()

    },
    getProviderList(){
      let data = {
        "name":"getProviderList",
        "page":1,"offset":1,"pagecount":100,
        "returntype":"Map","parammaps":{"providerName":""}
      }
      GetDataByName(data).then(response => {
        if (response.data.list !== null) {
          this.providerList = response.data.list
        }else{
          this.providerList = []
        }
      })
    },
    changeType(){
      this.listAdd = []
      this.$set(this.createTemp,'providerId','')
      this.$set(this.createTemp,'providerName','')
    },
    special_dialog_save(){
      console.log('特殊申购保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          console.log(this.listAdd)
          if (this.createTemp.orderNumber == '' || this.createTemp.orderNumber == null || this.createTemp.orderNumber == undefined) {
            GetDataByName(this.getParmCreateNumber).then(response => {
              this.$nextTick(() => {
                console.log('新增申购单号', response.data.list[0].orderCode)
                this.createTemp.orderNumber = response.data.list[0].orderCode
                this.$forceUpdate()
                this.special_dialog_saveSave()
              })
            })
          } else {
            this.special_dialog_saveSave()
          }
        }
      })
    },
    special_dialog_saveSave(){

      if (this.listAdd.length !== 0) {
        for (var j = 0; j < this.listAdd.length; j++) {
          console.log(this.listAdd[j].amount)
          if (this.listAdd[j].amount == null || this.listAdd[j].amount === '') {
            this.$message({ type: 'warning', message: '请检查申购数量是否未填写', duration: 2000 })
            return false
          } else {
            var rulesAmount = /^[1-9]\d*$/
            if (!rulesAmount.test(this.listAdd[j].amount)) {
              this.$message({ type: 'error', message: '申购数量请输入正整数', duration: 2000 })
              return false
            }
          }
          if(this.createTemp.purchaseType == '2'){
            if (this.createTemp.providerId !== '') {
              if (this.listAdd[j].price == '') {
                this.$message({ type: 'warning', message: '请检查单价是否为空', duration: 2000 })
                return false
              } else {
                if (parseFloat(this.listAdd[j].price) == 0) {
                  this.$message({ type: 'warning', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                  return false
                } else {
                  var rulesPrice = /^(([1-9]{1}\d*)|(0{1}))(\.\d{1,2})?$/
                  if (rulesPrice.test(this.listAdd[j].price) == false) {
                    this.$message({ type: 'error', message: '价格请输入正数,最多保留小数点后两位', duration: 2000 })
                    return false
                  }
                }
              }
            }
          }
        }
        if(this.createTemp.purchaseType == '1' || this.createTemp.purchaseType == '3' ){
          if(this.createTemp.providerId == ''){
            this.$message({ type: 'error', message: '请选择供应商', duration: 2000 })
            return false
          }
        }else{
          // if(this.createTemp.providerId == ''){
          //   this.$message({ type: 'error', message: '请选择供应商', duration: 2000 })
          //   return false
          // }
          if(this.createTemp.funderId == ''){
            this.$message({ type: 'error', message: '请选择垫付人', duration: 2000 })
            return false
          }
        }
        let url = 'authdata/spare/parts/requisitions'
        for(let i=0;i<this.listAdd.length;i++){
          this.$set(this.listAdd[i],'contractId',String(this.listAdd[i].contractId))
        }
        let data = {
          "pastureId": parseInt(this.createTemp.pastureId),
          "departmentId": parseInt(this.createTemp.departmentId),
          'departmentName':this.createTemp.departmentName,
          "orderNumber": this.createTemp.orderNumber,
          "createTime": this.createTemp.createTime,
          "employeId": this.createTemp.employeId,
          "providerName": this.createTemp.providerName,
          "purchaseType": parseInt(this.createTemp.purchaseType),
          "spot_list":this.listAdd
        }
        if(this.createTemp.purchaseType == '1' || this.createTemp.purchaseType == '3'){
          data.providerId = this.createTemp.providerId
          data.providerName =  this.providerList.find(obj => obj.id == this.createTemp.providerId).providerName
        }
        if(this.createTemp.funderId){
          data.funderId = this.createTemp.funderId
        }
        postJson(url, data).then(response => {
          if (response.msg !== 'fail') {
            this.get_table_data()
            this.dialogFormVisible = false
            this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          } else {
            failproccess(response, this.$notify)
          }
        })
        return true
      } else {
        this.$message({
          title: '',
          message: '请选择备件',
          type: 'warning',
          duration: 2000
        })
        return false
      }
    },
  }
}
</script>
<style lang="scss" scoped>
  .pagination-container{
    display: block !important;
  }
  /deep/ .el-badge__content.is-fixed{
    z-index: 1;
  }
</style>
<style lang="scss">
.el-step__head.is-success {
    color: #409EFF;
    border-color: #409EFF;
}
.el-step__title.is-success{
  color: #409EFF;
}
.el-step__head.is-process{
  color: #409EFF;
  border-color: #409EFF;
  .el-step__icon.is-text{
    background: #409EFF;
    color: #fff;
  }
}
.step-row{
  color: #000;
}
</style>
